import utime

def parseGPS(data):
    if data[0:6] == "$GPRMC":
        sdata = data.split(",")
        if sdata[2] == 'V':
            return(False)
        time = sdata[1][0:2] + ":" + sdata[1][2:4] + ":" + sdata[1][4:6]
        lat = decode(sdata[3]) #latitude
        dirLat = sdata[4]      #latitude direction N/S
        lon = decode(sdata[5]) #longitute
        dirLon = sdata[6]      #longitude direction E/W
        speed = sdata[7]       #Speed in knots
        trCourse = sdata[8]    #True course
        date = sdata[9][0:2] + "/" + sdata[9][2:4] + "/" + sdata[9][4:6] #date
 
        val = []
        val.append(int(sdata[9][4:6])+2000)
        val.append(int(sdata[9][2:4]))
        val.append(int(sdata[9][0:2]))
        val.append(int(sdata[1][0:2]))
        val.append(int(sdata[1][2:4]))
        val.append(int(sdata[1][4:6]))
        val.append(0)
        val.append(0)
        
        return(tuple(val))
        
def decode(coord):
    #Converts DDDMM.MMMMM > DD deg MM.MMMMM min
    x = coord.split(".")
    head = x[0]
    tail = x[1]
    deg = head[0:-2]
    min = head[-2:]
    return deg + " deg " + min + "." + tail + " min"
        
def set_date_time(rtc,data):

    gps_date = parseGPS(data)

    if gps_date is not False:
        # print(gps_date)
        ss = utime.mktime(gps_date)+10800 # GMT +3
        # print(utime.localtime(ss))
        rtc.datetime(utime.localtime(ss))
        # print(rtc.datetime())