from pyb import Pin
from pyb import LED,sync
from time import sleep
import json,utime
import pyb,gc,os,machine
from colors import *
import time

LCD_pin     = Pin('Y2',  Pin.OUT_PP) # LCD Light
VCC_LCD_pin = Pin('Y3',  Pin.OUT_PP) # LCD VCC
ETH_VCC_pin = Pin('Y1',  Pin.OUT_PP) # Ethernet W5500 VCC
GPS_VCC_pin = Pin('Y11', Pin.OUT_PP) # GPS

def getntptime():
    import socket,ustruct
    from struct import unpack
     # (date(2000, 1, 1) - date(1900, 1, 1)).days * 24*60*60
    NTP_DELTA = 3155673600
    host = "pool.ntp.org"
    NTP_QUERY = bytearray(48)
    NTP_QUERY[0] = 0x1b
    addr = socket.getaddrinfo(host,123)[0][-1]
    s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
    try:       
        res = s.sendto(NTP_QUERY, addr)
        msg = s.recvfrom(48)
    except:
        del(socket)
        del(unpack)
        gc.collect()    
        return 0
    finally:
        s.close()        
    dt = msg[0]    
    val = ustruct.unpack("!I", dt[40:44])
    del(socket)
    del(unpack)
    gc.collect()
    return val[0] - NTP_DELTA
    
def game(lcd,p_in1):
    
    from pyb import Accel
    import math
    
    acl = Accel() # Работает медленно
    # 
    #       +P 
    #        |
    # +R <---  ---> -R
    #        |
    #       -P
    # between -32 and 31    
    
    M_PI = 3.14159265359
  
    lcd.fillMonocolor( BLACK ) 
    lcd.drawRect(1,1,238,318,BLUE)   
    lcd.drawCircle(119,159,5,GREEN)
    
    X = 119
    Y = 159
    
    while True:
    
        pitch = int(-(math.atan2(acl.x(), math.sqrt(acl.y()*acl.y() + acl.z()*acl.z()))*180.0)/M_PI)
        roll = int((math.atan2(acl.y(), acl.z())*180.0)/M_PI)
        
        time.sleep(0.5)
       
        if (pitch < 0): 
            if (pitch < -10):
                if (Y > 16):
                    lcd.drawCircle(X,Y,5,BLACK)                
                    Y = Y -10
                    lcd.drawCircle(X,Y,5,GREEN)
   
        elif (pitch > 0): 
            if (pitch > 10):
                if (Y < 303):
                    lcd.drawCircle(X,Y,5,BLACK)                                    
                    Y = Y +10
                    lcd.drawCircle(X,Y,5,GREEN)
    
        if (roll < 0): 
            if (roll < -10):
                if (X < 223):
                    lcd.drawCircle(X,Y,5,BLACK)                
                    X = X +10
                    lcd.drawCircle(X,Y,5,GREEN)
   
        elif (roll > 0): 
            if (roll > 10):
                if (X > 16):
                    lcd.drawCircle(X,Y,5,BLACK)                                    
                    X = X-10
                    lcd.drawCircle(X,Y,5,GREEN)
        
        
        if p_in1.value(): 
            time.sleep(0.5)
            break
                
    del(Accel)
    del(math)
    gc.collect()


def power_off_on(state):
    if state:
        LCD_pin.high()
        VCC_LCD_pin.high()
        ETH_VCC_pin.high()
        GPS_VCC_pin.high()
    else:
        LCD_pin.low()
        # VCC_LCD_pin.low() # Потребление увеличивается до 66 мА
        ETH_VCC_pin.low()
        GPS_VCC_pin.low()

# led1 = LED(1) # 1=red, 2=green, 3=yellow, 4=blue
# led2 = LED(2) # 1=red, 2=green, 3=yellow, 4=blue

'''
def led_on_off(state):
    if state:
        led1.on()
        led2.on()
        LED(3).intensity(20) # PWM
        LED(4).intensity(20) # PWM
    else:
        led1.off()
        led2.off()
        LED(3).intensity(0) # PWM
        LED(4).intensity(0) # PWM

'''


'''
def led_strobe():
    led1.on()
    sleep(0.2)
    led2.on()
    sleep(0.2)
    LED(3).intensity(20) # PWM
    sleep(0.2)
    LED(4).intensity(20) # PWM
    sleep(0.2)
    led1.off()
    sleep(0.2)
    led2.off()
    sleep(0.2)
    LED(3).intensity(0) # PWM
    sleep(0.2)
    LED(4).intensity(0) # PWM
    sleep(0.2)
    
    LED(4).intensity(20) # PWM
    sleep(0.2)    
    LED(3).intensity(20) # PWM
    sleep(0.2)    
    led2.on()
    sleep(0.2)    
    led1.on()
    sleep(0.2)
    LED(4).intensity(0) # PWM
    sleep(0.2)    
    LED(3).intensity(0) # PWM
    sleep(0.2)    
    led2.off()
    sleep(0.2)    
    led1.off()
    sleep(0.2)
'''

@micropython.native
def rtc_show(rtc):
    
    h = rtc[4]
    m = rtc[5]
    s = rtc[6]

    year  = rtc[0]
    month = rtc[1]
    day   = rtc[2]
    
    # --- Time
    if h<10: hs='0'+str(h)
    else: hs=str(h)
    if s<10: ss='0'+str(s)
    else: ss=str(s)
    if m<10: ms='0'+str(m)
    else: ms=str(m)

    # --- Date
    
    if month<10: smonth='0'+str(month)
    else: smonth=str(month)
    
    if day<10: sday='0'+str(day)
    else: sday=str(day)
                
    return(sday+'/'+smonth+'/'+str(year-2000)+' '+hs+':'+ms) # +':'+ss)

def show_real_data(lcd,temp,p,h,cpu,alt,srtc):    
    
    t = lcd.initCh(color=GREEN, font='Arial_14')
    
    lcd.drawRect(0,185, 239, 148, BLACK, border=1, infill=BLACK) 
    
    t = lcd.initCh(color=GREEN, font='Arial_14')
    t.printLn('T: '+str(int(temp))+'\'C',15,185,scale=2)  
    gc.collect()
    t.printLn('M: '+str(int(gc.mem_free()/1024)),150,250,scale=2)
        
    t = lcd.initCh(color=YELLOW, font='Arial_14')    
    t.printLn(srtc,15,285,scale=2)    
    t.printLn('B: '+str(int(p/133)+5),15,220,scale=2) # +5 Поправка Yandex
    t = lcd.initCh(color=MAGENTA, font='Arial_14')    
    t.printLn('H: '+str(int(h))+'%',125,185,scale=2)
    t = lcd.initCh(color=BLUE, font='Arial_14')    
    t.printLn('CPU: '+str(int(cpu))+'\'C',12,250,scale=2)
    t = lcd.initCh(color=GREENYELLOW, font='Arial_14')    
    t.printLn('A: '+str(int(alt)),125,220,scale=2)
    
    del t
    gc.collect()
    
    
        
def make_json_data_file(id,name):

    data = {}
    data[id] = []
     
    currentUnixTime = utime.time()   
    pos = int(((currentUnixTime/1800)%192))
            
    for i in range(192):    
        data[id].append({'pos':i+1,'time':0,id:0})

    with open('/win/'+name, 'w') as outfile:
        json.dump(data, outfile)
        
    sync()
    gc.collect()
        
        
# ----------------------------- Save Temperature to file ---------------------

def save_data_to_file(pos,unixtime,id,data):

    with open('/win/data_'+id+'.txt') as json_file:
        try:
            fdata = json.load(json_file)
        except:
            os.remove('/win/data_'+id+'.txt') # если ошибка в файле            
            machine.reset()
            
    for p in fdata[id]:
        if (p['pos'] == pos):
            p['time'] = unixtime
            p[id] = data
        
    with open('/win/data_'+id+'.txt', 'w') as outfile:
        json.dump(fdata, outfile)
        
    sync() # Sync All Filesystems          
    gc.collect()
    
def mapx(x,in_min,in_max,out_min,out_max):
    return int((x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min)

def grid(lcd):

    for x in range(30,215,10):
        for y in range(25,170,5):
            lcd.drawPixel(x,y,GREEN)

    for y in range(25,170,5):
        for x in range(25,215,5):
            lcd.drawPixel(x,y,GREEN)

def show_max_min(lcd,dmax,dmin,X):
    # X = 0 для давления
    # X = 220 для температуры
    
    lcd.drawRect(X,0,19,170,BLACK,infill=BLACK)   
    o = lcd.initCh(color=GREENYELLOW, font='Vera_m10')
    o.printLn(str(int(dmax)),X,20,scale=1)
    o.printLn(str(int((((dmax+dmin)/2)+dmax)/2)),X,55,scale=1) #
    o.printLn(str(int((dmax+dmin)/2)),X,90,scale=1)
    o.printLn(str(int((((dmax+dmin)/2)+dmin)/2)),X,125,scale=1) #
    o.printLn(str(int(dmin)),X,160,scale=1)

# ----------------------- Show Temp ---------------------------------
    
def show_temp(lcd):    

    gc.collect()  
    
    with open('/win/data_temp.txt') as json_file:
        fdata = json.load(json_file)

    tempUtime = []
    tempData = []
    tempMaxMin = []
    
    FOUR_DAYS = 345600
    
    for p in fdata['temp']:   
        if p['time'] > 0 and (utime.time() - p['time']) <= FOUR_DAYS:
            tempMaxMin.append(p['temp'])            
        
        tempData.append(p['temp'])
        tempUtime.append(p['time'])
    
    tmin = min(tempMaxMin)-3
    tmax = max(tempMaxMin)+3        
    
    show_max_min(lcd,tmax,tmin,220)
    
    xL=[] # [192]
    yL=[] # [192]
    
    current_position = int((utime.time()/1800)%192)
    
    # print(current_position,(utime.time()/1800)%192,utime.time())
    
    if current_position > 0:
        current_position = current_position - 1
        
    k = 0
    x_pos = 213
    
    for i in range(len(tempData)):         
        if tempUtime[current_position] > 0 and (utime.time() - tempUtime[current_position]) <= FOUR_DAYS:
            h = mapx(tempData[current_position],tmin,tmax,1,146)            
            xL.append(x_pos)
            yL.append((146+22)-h)
            k+=1
            x_pos-=1         
        else:        
            x_pos-=1
     
        if (current_position == 0): 
            current_position = 191
        else: 
            current_position-=1
  
   
    for j in range(0,k):
        if ((j+1) < k):
            lcd.drawLine(xL[j],yL[j],xL[(j+1)],yL[(j+1)],YELLOW)
   
# -------------------------- Show_Bar ---------------------------------------

def show_bar(l):     
      
    with open('/win/data_bar.txt') as json_file:
        fdata = json.load(json_file)

    barUtime = []
    barMaxMin = []
    barData = []
    
    show_pos = 0
    
    FOUR_DAYS = 345600
    
    for p in fdata['bar']:   
        if p['bar'] > 0 and p['time'] > 0 and (utime.time() - p['time']) <= FOUR_DAYS:
            barMaxMin.append(p['bar']*10)           
        barData.append(p['bar']*10)        
        barUtime.append(p['time'])
        
    pmin = min(barMaxMin)
    pmax = max(barMaxMin)

    dmax = int(pmax/10)
    dmin = int(pmin/10)
    
    if ((pmax % 5) > 0): 
        pmax=((pmax /5)+1)*5
        
    pmin=(pmin/10)*10

    scale=(pmax-pmin)/146.0  # без INT все намного лучше - 146 Max Heght of Line
  
    if scale>50: scale=100
    elif scale>20: scale=50
    elif scale>10: scale=20
    elif scale>5: scale=10
    elif scale>2: scale=5
    elif scale>1: scale=2
    else: scale=1

    x_pos = 213
    
    current_position = int((utime.time()/1800)%192)
    if current_position > 0:
        current_position = current_position - 1
    
    l.drawRect(20,20,195,150,BLUE,infill=BLACK)   
    grid(l)
    
    show_max_min(l,dmax-700,dmin-700,0)
    l.drawRect(0,173,239,12, BLACK, border=1, infill=BLACK)  # Show_Time_Scale clear
    
    for i in range(len(barData)):
        if barData[current_position] > 0 and barUtime[current_position] > 0 and (utime.time() - barUtime[current_position]) <= FOUR_DAYS:
            # l.drawVline(x_pos,22,146,BLACK)
            # h = mapx(barData[current_position],min(barMaxMin),max(barMaxMin),1,146)    
            if (show_pos <= 160):
                show_time_scale(barUtime[current_position],show_pos,l)  # 0,20,40,60,80,100,120,140,160,180
                show_pos+=1       
     
            h = int((barData[current_position]-pmin)/scale)
            # print(h)
            if h>146: h=146
            # print(barData[current_position],h,scale)
            if (h==0): h=1
            l.drawVline(x_pos,(146+22)-h,h,MAGENTA)
            x_pos=x_pos-1  
        else:
            x_pos=x_pos-1
            show_pos+=1
            
        if current_position == 0: 
            current_position = 191
        else:
            current_position=current_position-1
    
    gc.collect()
    
def heart(m,lcd): # m = MAX30102 
    import hrcalc    
    #tim = pyb.Timer(4)             
    #tim.init(freq=2) # trigger at 2Hz
    #tim.callback(lambda t:pyb.LED(1).toggle())    
    gc.collect()
    m.reset()
    m.setup()
    lcd.drawRect(0,0,239,95,WHITE,infill=WHITE)
    lcd.printLn('Please Touch.',10,70,scale=1)
    # m = max30102.MAX30102(pin='Y4')
    red, ir = m.read_sequential(1000)
    ir_avg = []
    red_avg = []
    ir_D = 0
    red_D = 0
    for i in range(37):
        d = hrcalc.calc_hr_and_spo2(ir[25*i:25*i+100], red[25*i:25*i+100])                
        if d[1]:
            ir_avg.append(d[0])
        if d[3]:
            red_avg.append(d[2])
    try:
        ir_D = (sum(ir_avg) - max(ir_avg) - min(ir_avg)) // len(ir_avg)
    except:
        pass
    
    try:
        red_D = (sum(red_avg) - max(red_avg) - min(red_avg)) // len(red_avg)
    except:
        pass
        
    lcd.printLn('SPO2: '+str(int(ir_D)) ,10,250,scale=1)
    lcd.printLn('HR:   '+str(int(red_D)),10,280,scale=1)        
    #tim.deinit()
    #LED(1).off()
    m.shutdown()
    time.sleep(15)
    del(hrcalc)
    gc.collect()

def Hour(uTime):
    tTime = utime.localtime(uTime)
    return(str(tTime[3]))
                
def show_time_scale(uTime,show_pos,lcd ):

    Y=173
    X=[]
    Apos = 0
            
    X.append(21)
    X.append(43)
    X.append(65)
    X.append(87)
    X.append(110)
    X.append(132)
    X.append(155)
    X.append(177)
    X.append(200)
    
    X.reverse()

    o = lcd.initCh(color=GREEN, font='Vera_m10')
        
    if (show_pos%20) == 0:
        if (show_pos == 0): 
            Apos = 0
        else: 
            Apos = int(show_pos / 20)
            
        o.printLn(Hour(uTime),X[Apos],173,scale=1)   